package cn.iocoder.yudao.module.product.vo.product;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
* 商品 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class ProductBaseVO {

    @ApiModelProperty(value = "商品类型id", required = true)
    @NotNull(message = "商品类型id不能为空")
    private Long typeId;

    @ApiModelProperty(value = "商品类型中文名称")
    private String typeTitleZh;

    @ApiModelProperty(value = "商品类型英文名称")
    private String typeTitleEn;

    @ApiModelProperty(value = "商品特效id", required = true)
    @NotNull(message = "商品属性id不能为空")
    private String attrId;

    @ApiModelProperty(value = "中文标题")
    private String titleZh;

    @ApiModelProperty(value = "英文标题")
    private String titleEn;

    @ApiModelProperty(value = "商品材质,字典material_type")
    private String materialType;

    @ApiModelProperty(value = "出运要求,1表示下单该类货物需要提供特定证书")
    private Integer requirements;

    @ApiModelProperty(value = "包装（字典packaging_type）")
    private String packaging;

    @ApiModelProperty(value = "图片")
    private String imgs;

    @ApiModelProperty(value = "商品编码")
    private String productCode;

    @ApiModelProperty(value = "海关编码")
    private String customsCode;

    @ApiModelProperty(value = "默认货柜位置，字典container_location")
    private String containerLocation;

    @ApiModelProperty(value = "默认方数")
    private BigDecimal square;

    @ApiModelProperty(value = "空运重量上限")
    private BigDecimal airWeightLimit;

    @ApiModelProperty(value = "是否需要预约入仓，0-否，1-是")
    private Integer needBook;

    @ApiModelProperty(value = "每日入仓上限")
    private BigDecimal dayLimit;

    @ApiModelProperty(value = "审核状态，0-已审核，1-未审核")
    private Integer auditStatus;

    @ApiModelProperty(value = "是否展示 默认为展示")
    private Integer status;

}
