package cn.iocoder.yudao.module.product.dal.dataobject.product;

import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

import java.math.BigDecimal;
import java.util.List;

/**
 * 产品 DO
 *
 * @author wlh
 */
@TableName("ecw_product")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ProductDO extends BaseDO {
    /**
     *
     */
    @TableId
    private Long id;

    /**
     * 产品类型id
     */
    private Long typeId;
    /**
     * 产品属性id
     */
    private String attrId;
    /**
     * 中文标题
     */
    private String titleZh;
    /**
     * 英文标题
     */
    private String titleEn;

    /**
     * 商品材质
     */
    private String materialType;

    /**
     * 出运要求,1表示下单该类货物需要提供特定证书
     */
    private Integer requirements;

    /**
     * 包装（字典packaging_type）
     */
    private String packaging;

    /**
     * 图片
     */
    private String imgs;

    /**
     * 商品编码
     */
    private String productCode;

    /**
     * 海关编码
     */
    private String customsCode;

    /**
     * 默认货柜位置，字典container_location
     */
    private String containerLocation;

    /**
     * 默认方数
     */
    private BigDecimal square;

    /**
     * 空运重量上限
     */
    private BigDecimal airWeightLimit;

    /**
     * 是否需要预约入仓，0-否，1-是
     */
    private Integer needBook;

    /**
     * 每日入仓上限
     */
    private BigDecimal dayLimit;
    /**
     * 审核状态，0-已审核，1-未审核
     */
    private Integer auditStatus;
    /**
     * 是否展示 默认为展示
     */
    private Integer status;

    /**
     * 属性列表
     */
    @TableField(exist = false)
    private List<ProductAttrDO> attrList;


    /**
     * 空运清关费阶梯价格数量
     */
    @TableField(exist = false)
    private Long priceStepClearanceCount;

    /**
     * 产品路线价格数量
     */
    @TableField(exist = false)
    private Long priceLineCount;


    /**
     * 创建人
     */
    @TableField(exist = false)
    private String creatorName;

    /**
     * 更新人
     */
    @TableField(exist = false)
    private String updaterName;

}
