package cn.iocoder.yudao.module.product.controller.admin.productbrank;

import cn.hutool.core.collection.CollectionUtil;
import cn.iocoder.yudao.module.product.convert.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelConvert;
import cn.iocoder.yudao.module.product.convert.productBrandTrademarkRel.ProductBrandTrademarkRelConvert;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductDO;
import cn.iocoder.yudao.module.product.dal.dataobject.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelDO;
import cn.iocoder.yudao.module.product.dal.dataobject.productBrandTrademarkRel.ProductBrandTrademarkRelDO;
import cn.iocoder.yudao.module.product.enums.ErrorCodeConstants;
import cn.iocoder.yudao.module.customer.service.customer.CustomerService;
import cn.iocoder.yudao.module.product.service.product.ProductService;
import cn.iocoder.yudao.module.product.service.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelService;
import cn.iocoder.yudao.module.product.service.productBrandTrademarkRel.ProductBrandTrademarkRelService;
import cn.iocoder.yudao.module.product.service.productBrandUnauthEmpower.ProductBrandUnauthEmpowerService;
import cn.iocoder.yudao.module.product.service.productbrandempower.ProductBrandEmpowerService;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelRespVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkRel.ProductBrandTrademarkRelPageReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkRel.ProductBrandTrademarkRelRespVO;
import cn.iocoder.yudao.module.product.vo.productBrandUnauthEmpower.ProductBrandUnauthEmpowerUpdateReqVO;
import cn.iocoder.yudao.module.product.vo.productbrandempower.GetFeeTypeProductBrandByOrderEmpowerReqVO;
import cn.iocoder.yudao.module.product.vo.productbrandempower.GetFeeTypeProductBrandEmpowerReqVO;
import cn.iocoder.yudao.module.product.vo.productbrandempower.GetFeeTypeProductBrandEmpowerRespVO;
import cn.iocoder.yudao.module.product.vo.productbrank.*;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

import org.springframework.validation.annotation.Validated;
import io.swagger.annotations.*;

import javax.validation.*;
import javax.servlet.http.*;
import java.util.*;
import java.io.IOException;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.CommonResult;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.error;
import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

import cn.iocoder.yudao.framework.excel.util.ExcelUtils;
import cn.iocoder.yudao.framework.operatelog.core.annotations.OperateLog;

import static cn.iocoder.yudao.framework.operatelog.core.enums.OperateTypeEnum.*;

import cn.iocoder.yudao.module.product.dal.dataobject.productbrank.ProductBrankDO;
import cn.iocoder.yudao.module.product.convert.productbrank.ProductBrankConvert;
import cn.iocoder.yudao.module.product.service.productbrank.ProductBrankService;

@Validated
@RestController
@Api(tags = "管理后台 - 品牌")
@RequestMapping("/ecw/product-brank")
public class ProductBrankController {

    @Resource
    private ProductBrankService productBrankService;
    @Resource
    ProductBrandTrademarkRelService productBrandTrademarkRelService;
    @Resource
    ProductBrandTrademarkCateogryRelService productBrandTrademarkCateogryRelService;
    @Resource
    ProductService productService;
    @Resource
    CustomerService customerService;
    @Resource
    ProductBrankService productBrandService;
    @Resource
    ProductBrandEmpowerService productBrandEmpowerService;

    @PostMapping("/create")
    @ApiOperation("创建品牌")
    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:create')")
    public CommonResult<Long> createProductBrank(@Valid @RequestBody ProductBrankCreateReqVO createReqVO) {
        return success(productBrankService.createProductBrank(createReqVO));
    }

    @PostMapping("/createByName")
    @ApiOperation("只有名称创建品牌")
    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:create')")
    public CommonResult<Long> createByNameProductBrank(@Valid @RequestBody ProductBrankCreateReqByNameVO createReqVO) {
        ProductBrankCreateReqVO reqVO=new ProductBrankCreateReqVO();
        reqVO.setTitleZh(createReqVO.getTitleZh());
        reqVO.setTitleEn(createReqVO.getTitleZh());
        //默认为已备案
        reqVO.setFiling("1");
        reqVO.setUnauthChargingModel("0");
        reqVO.setUnauthDefaultFeeType("1");
        return success(productBrankService.createProductBrank(reqVO));
    }



    @PutMapping("/update")
    @ApiOperation("更新品牌")
    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:update')")
    public CommonResult<Boolean> updateProductBrank(@Valid @RequestBody ProductBrankUpdateReqVO updateReqVO) {
        productBrankService.updateProductBrank(updateReqVO);
        return success(true);
    }


    @PutMapping("/changeFeeMode")
    @ApiOperation("修改品牌默认收费模式")
    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:update')")
    public CommonResult<Boolean> changeProductBrankFeeMode(@Valid @RequestBody ProductBrankChangeFeeModeReqVO updateReqVO) {
        productBrankService.changeProductBrankFeeMode(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @ApiOperation("删除品牌")
    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:delete')")
    public CommonResult<Boolean> deleteProductBrank(@RequestParam("id") Long id) {
        productBrankService.deleteProductBrank(id);
        return success(true);
    }

    @GetMapping("/get")
    @ApiOperation("获得品牌")
    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:query')")
    public CommonResult<ProductBrankRespVO> getProductBrank(@RequestParam("id") Long id) {
        ProductBrankDO productBrank = productBrankService.getProductBrank(id);
        ProductBrankRespVO respVO = ProductBrankConvert.INSTANCE.convert(productBrank);
        ProductBrandTrademarkRelPageReqVO pageReqVO = new ProductBrandTrademarkRelPageReqVO();
        pageReqVO.setProductBrandId(id);
        pageReqVO.setPageNo(1);
        pageReqVO.setPageSize(100);
        PageResult<ProductBrandTrademarkRelDO> productBrandTrademarkRelDOPageResult = productBrandTrademarkRelService.getProductBrandTrademarkRelPage(pageReqVO);
        //查询出品牌下商标
        List<ProductBrandTrademarkRelDO> trademarkRelDOList = productBrandTrademarkRelDOPageResult.getList();
        //转换成返回类型
        List<ProductBrandTrademarkRelRespVO> trademarkRelRespVOList=ProductBrandTrademarkRelConvert.INSTANCE.convertList(trademarkRelDOList);

        if (CollectionUtil.isNotEmpty(trademarkRelRespVOList)) {
            for (ProductBrandTrademarkRelRespVO relDO : trademarkRelRespVOList) {
                //查询商标对应的商品分类
                List<ProductBrandTrademarkCateogryRelDO> list = productBrandTrademarkCateogryRelService.selectList("trademark_id",relDO.getId());
                List<ProductBrandTrademarkCateogryRelRespVO> relRespList =
                            ProductBrandTrademarkCateogryRelConvert.INSTANCE.convertList(list);

                relDO.setTrademarkCategoryRelList(relRespList);
            }

        }

        respVO.setTrademarkList(trademarkRelRespVOList);

        return success(respVO);
    }

//    @GetMapping("/list")
//    @ApiOperation("获得品牌列表")
////    @ApiImplicitParam(name = "ids", value = "编号列表", required = true, example = "1024,2048", dataTypeClass = List.class)
//    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:query')")
//    public CommonResult<List<ProductBrankRespVO>> getProductBrankList(@RequestParam("ids") Collection<Long> ids) {
//        List<ProductBrankDO> list = productBrankService.getProductBrankList(ids);
//        return success(ProductBrankConvert.INSTANCE.convertList(list));
//    }

    @GetMapping("/page")
    @ApiOperation("获得品牌分页")
    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:query')")
    public CommonResult<PageResult<ProductBrankRespVO>> getProductBrankPage(@Valid ProductBrankPageReqVO pageVO) {
        PageResult<ProductBrankDO> pageResult = productBrankService.getProductBrankPage(pageVO);
        return success(ProductBrankConvert.INSTANCE.convertPage(pageResult));
    }
    @PostMapping("/getBrankByCustomer")
    @ApiOperation("查看某客户授权的品牌")
    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:query')")
    public CommonResult<PageResult<ProductBrandMyEmpowerRespVO>> getBrankByCustomer(
            @Valid @RequestBody ProductBrankByCustomerPageReqVO createReqVO) {
        PageResult<ProductBrandMyEmpowerRespVO> pageResult =
                productBrankService.getBrankByCustomer(createReqVO);
        return success(pageResult);
    }
    @GetMapping("/export-excel")
    @ApiOperation("导出品牌 Excel")
    //@PreAuthorize("@ss.hasPermission('ecw:product-brank:export')")
    @OperateLog(type = EXPORT)
    public void exportProductBrankExcel(@Valid ProductBrankExportReqVO exportReqVO,
                                        HttpServletResponse response) throws IOException {
        List<ProductBrankDO> list = productBrankService.getProductBrankList(exportReqVO);
        // 导出 Excel
        List<ProductBrankExcelVO> datas = ProductBrankConvert.INSTANCE.convertList02(list);
        ExcelUtils.write(response, "品牌.xls", "数据", ProductBrankExcelVO.class, datas);
    }

    @PostMapping("/getFeeTypeByCustomerProduct")
    @ApiOperation("根据品牌id,商品id、客户id查询对客户的产品收费模式")
    public CommonResult<GetFeeTypeProductBrandEmpowerRespVO> getFeeTypeByCustomerProduct(
            @Valid @RequestBody GetFeeTypeProductBrandEmpowerReqVO reqVO
    ) {
        ProductDO productDO = productService.getProduct(reqVO.getProductId());
        if (productDO == null) {
            return error(ErrorCodeConstants.PRODUCT_NOT_EXISTS);
        }
        GetFeeTypeProductBrandEmpowerRespVO respVO = productBrandEmpowerService.getFeeTypeProductBrandEmpower(reqVO);
        return success(respVO);
    }


    @PostMapping("/getFeeTypeByOrderProduct")
    @ApiOperation("根据品牌id、商品id、订单id 查询对客户的产品收费模式")
    public CommonResult<GetFeeTypeProductBrandEmpowerRespVO> getFeeTypeByOrderProduct(
            @Valid @RequestBody GetFeeTypeProductBrandByOrderEmpowerReqVO reqVO
    ) {
        ProductDO productDO = productService.getProduct(reqVO.getProductId());
        if (productDO == null) {
            return error(ErrorCodeConstants.PRODUCT_NOT_EXISTS);
        }
        GetFeeTypeProductBrandEmpowerRespVO respVO =
                productBrandEmpowerService.getFeeTypeByOrder(reqVO);
        return success(respVO);
    }

    @Resource
    private ProductBrandUnauthEmpowerService productBrandUnauthEmpowerService;
    @PutMapping("/setUnauthCustomerFeeType")
    @ApiOperation("更新商品品牌-未授权客户-修改单个未授权客户的指定收费标准")
    //@PreAuthorize("@ss.hasPermission('ecw:product-brand-unauth-empower:update')")
    public CommonResult<Boolean> updateProductBrandUnauthEmpower(@Valid @RequestBody ProductBrandUnauthEmpowerUpdateReqVO updateReqVO) {
        boolean result=productBrandUnauthEmpowerService.updateProductBrandUnauthEmpower(updateReqVO);
        return result?success(true):error(ErrorCodeConstants.COST_CALCULATION_ERROR);
    }
}
